<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eicd: src/ClusterCollection.cc Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eicd
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">ClusterCollection.cc</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_cluster_collection_8cc.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// AUTOMATICALLY GENERATED FILE - DO NOT EDIT</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_cluster_collection_8h.html">eicd/ClusterCollection.h</a>&quot;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_calorimeter_hit_collection_8h.html">eicd/CalorimeterHitCollection.h</a>&quot;</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_cluster_collection_8h.html">eicd/ClusterCollection.h</a>&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">// standard includes</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;iomanip&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceeic.html">eic</a> {</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a8fa56b59b339384399af2c26716ccae9">   15</a></span>&#160;<a class="code" href="classeic_1_1_cluster_collection.html#a8fa56b59b339384399af2c26716ccae9">ClusterCollection::ClusterCollection</a>() :</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;  m_isValid(false), m_collectionID(0), m_entries(),</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;  m_rel_clusters(new std::vector&lt;<a class="code" href="namespaceeic.html">eic</a>::<a class="code" href="classeic_1_1_const_cluster.html">ConstCluster</a>&gt;()),</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;  m_rel_hits(new std::vector&lt;<a class="code" href="namespaceeic.html">eic</a>::<a class="code" href="classeic_1_1_const_calorimeter_hit.html">ConstCalorimeterHit</a>&gt;()),</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;  m_data(new <a class="code" href="namespaceeic.html#a4b2806ccf4a8e9e4f7875e0b329d4700">ClusterDataContainer</a>()) {</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;  m_refCollections.push_back(<span class="keyword">new</span> std::vector&lt;podio::ObjectID&gt;());</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;  m_refCollections.push_back(<span class="keyword">new</span> std::vector&lt;podio::ObjectID&gt;());</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;}</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#ac6eb35a42fe7b108febddc5547b624cd">   24</a></span>&#160;<a class="code" href="classeic_1_1_cluster_collection.html#ac6eb35a42fe7b108febddc5547b624cd">ClusterCollection::~ClusterCollection</a>() {</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;  <a class="code" href="classeic_1_1_cluster_collection.html#a1346e31bcd6c87de757cca70dcd1b8b6">clear</a>();</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;  <span class="keywordflow">if</span> (m_data) <span class="keyword">delete</span> m_data;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_refCollections) { <span class="keywordflow">if</span> (pointer) <span class="keyword">delete</span> pointer; }</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  <span class="keywordflow">if</span> (m_rel_clusters) <span class="keyword">delete</span> m_rel_clusters;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;  <span class="keywordflow">if</span> (m_rel_hits) <span class="keyword">delete</span> m_rel_hits;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;}</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a04df429e9bc0083748371067dc9b4a79">   32</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a> <a class="code" href="classeic_1_1_cluster_collection.html#a04df429e9bc0083748371067dc9b4a79">ClusterCollection::operator[]</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)<span class="keyword"> const </span>{</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a>(m_entries[index]);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;}</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a1e0a38ddf496eee61e5b7b73812b69bf">   36</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a> <a class="code" href="classeic_1_1_cluster_collection.html#a1e0a38ddf496eee61e5b7b73812b69bf">ClusterCollection::at</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index)<span class="keyword"> const </span>{</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a>(m_entries.at(index));</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;}</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#afbf8158a947aac64a6a7e5ac131e59a8">   40</a></span>&#160;<a class="code" href="classeic_1_1_cluster.html">Cluster</a> <a class="code" href="classeic_1_1_cluster_collection.html#a04df429e9bc0083748371067dc9b4a79">ClusterCollection::operator[]</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) {</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a>(m_entries[index]);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;}</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a2570c1c51a804510f7e99870a3675ad2">   44</a></span>&#160;<a class="code" href="classeic_1_1_cluster.html">Cluster</a> <a class="code" href="classeic_1_1_cluster_collection.html#a1e0a38ddf496eee61e5b7b73812b69bf">ClusterCollection::at</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) {</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a>(m_entries.at(index));</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">   48</a></span>&#160;<span class="keywordtype">size_t</span> <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">ClusterCollection::size</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  <span class="keywordflow">return</span> m_entries.size();</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;}</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#ad0f736c97d234af7faf81f2316d89a36">   52</a></span>&#160;<a class="code" href="classeic_1_1_cluster.html">Cluster</a> <a class="code" href="classeic_1_1_cluster_collection.html#ad0f736c97d234af7faf81f2316d89a36">ClusterCollection::create</a>() {</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;  <span class="keyword">auto</span> obj = m_entries.emplace_back(<span class="keyword">new</span> <a class="code" href="classeic_1_1_cluster_obj.html">ClusterObj</a>());</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  m_rel_clusters_tmp.push_back(obj-&gt;m_clusters);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  m_rel_hits_tmp.push_back(obj-&gt;m_hits);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  obj-&gt;id = {int(m_entries.size() - 1), m_collectionID};</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;  <span class="keywordflow">return</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a>(obj);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;}</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a1346e31bcd6c87de757cca70dcd1b8b6">   61</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_cluster_collection.html#a1346e31bcd6c87de757cca70dcd1b8b6">ClusterCollection::clear</a>() {</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  m_data-&gt;clear();</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_refCollections) { pointer-&gt;clear(); }</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="comment">// clear relations to clusters. Make sure to unlink() the reference data as they may be gone already.</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_rel_clusters_tmp) {</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; item : *pointer) {</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;      item.unlink();</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    }</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keyword">delete</span> pointer;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  }</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  m_rel_clusters_tmp.clear();</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; item : (*m_rel_clusters)) { item.unlink(); }</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  m_rel_clusters-&gt;clear();</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="comment">// clear relations to hits. Make sure to unlink() the reference data as they may be gone already.</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_rel_hits_tmp) {</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; item : *pointer) {</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;      item.unlink();</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    }</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keyword">delete</span> pointer;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;  }</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  m_rel_hits_tmp.clear();</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; item : (*m_rel_hits)) { item.unlink(); }</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;  m_rel_hits-&gt;clear();</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; obj : m_entries) { <span class="keyword">delete</span> obj; }</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;  m_entries.clear();</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;}</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a26edef89c8964b3bd1d04374c2ecd9d9">   90</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_cluster_collection.html#a26edef89c8964b3bd1d04374c2ecd9d9">ClusterCollection::prepareForWrite</a>() {</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a> = m_entries.size();</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;  m_data-&gt;reserve(<a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a>);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; obj : m_entries) { m_data-&gt;push_back(obj-&gt;data); }</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; pointer : m_refCollections) { pointer-&gt;clear(); }</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  <span class="keywordtype">int</span> clusters_index = 0;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;  <span class="keywordtype">int</span> hits_index = 0;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0, <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a> = m_data-&gt;size(); i != <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a>; ++i) {</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    (*m_data)[i].clusters_begin = clusters_index;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    (*m_data)[i].clusters_end += clusters_index;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    clusters_index = (*m_data)[i].clusters_end;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; it : (*m_rel_clusters_tmp[i])) {</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;      <span class="keywordflow">if</span> (it.getObjectID().index == podio::ObjectID::untracked) {</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;Trying to persistify untracked object&quot;</span>);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;      }</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;      m_refCollections[0]-&gt;emplace_back(it.getObjectID());</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;      m_rel_clusters-&gt;push_back(it);</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    }</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    (*m_data)[i].hits_begin = hits_index;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    (*m_data)[i].hits_end += hits_index;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    hits_index = (*m_data)[i].hits_end;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; it : (*m_rel_hits_tmp[i])) {</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;      <span class="keywordflow">if</span> (it.getObjectID().index == podio::ObjectID::untracked) {</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;Trying to persistify untracked object&quot;</span>);</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;      }</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;      m_refCollections[1]-&gt;emplace_back(it.getObjectID());</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;      m_rel_hits-&gt;push_back(it);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    }</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;  }</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;}</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a8ab71f2656724b8c370dbac47e9869b7">  124</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_cluster_collection.html#a8ab71f2656724b8c370dbac47e9869b7">ClusterCollection::prepareAfterRead</a>() {</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;  <span class="keywordtype">int</span> index = 0;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;  <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; data : *m_data) {</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keyword">auto</span> obj = <span class="keyword">new</span> <a class="code" href="classeic_1_1_cluster_obj.html">ClusterObj</a>({index, m_collectionID}, data);</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    obj-&gt;<a class="code" href="classeic_1_1_cluster_obj.html#aab30fa33cb765e4aa0f3540b308234a5">m_clusters</a> = m_rel_clusters;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    obj-&gt;m_hits = m_rel_hits;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    m_entries.emplace_back(obj);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    ++index;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;  }</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  m_isValid = <span class="keyword">true</span>;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;}</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#ad532b11026e8f96ac806f345c9046f30">  137</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classeic_1_1_cluster_collection.html#ad532b11026e8f96ac806f345c9046f30">ClusterCollection::setReferences</a>(<span class="keyword">const</span> podio::ICollectionProvider* collectionProvider) {</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0, <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a> = m_refCollections[0]-&gt;<a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a>(); i != <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a>; ++i) {</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keyword">const</span> <span class="keyword">auto</span> <span class="keywordtype">id</span> = (*m_refCollections[0])[i];</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keywordflow">if</span> (<span class="keywordtype">id</span>.index != podio::ObjectID::invalid) {</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;      CollectionBase* coll = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;      collectionProvider-&gt;get(<span class="keywordtype">id</span>.collectionID, coll);</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;      <a class="code" href="classeic_1_1_cluster_collection.html">eic::ClusterCollection</a>* tmp_coll = <span class="keyword">static_cast&lt;</span><a class="code" href="classeic_1_1_cluster_collection.html">eic::ClusterCollection</a>*<span class="keyword">&gt;</span>(coll);</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;      <span class="keyword">const</span> <span class="keyword">auto</span> tmp = (*tmp_coll)[<span class="keywordtype">id</span>.index];</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;      m_rel_clusters-&gt;emplace_back(tmp);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;      m_rel_clusters-&gt;emplace_back(<span class="keyword">nullptr</span>);</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    }</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;  }</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0, <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a> = m_refCollections[1]-&gt;<a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a>(); i != <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a>; ++i) {</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keyword">const</span> <span class="keyword">auto</span> <span class="keywordtype">id</span> = (*m_refCollections[1])[i];</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <span class="keywordflow">if</span> (<span class="keywordtype">id</span>.index != podio::ObjectID::invalid) {</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;      CollectionBase* coll = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;      collectionProvider-&gt;get(<span class="keywordtype">id</span>.collectionID, coll);</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;      <a class="code" href="classeic_1_1_calorimeter_hit_collection.html">eic::CalorimeterHitCollection</a>* tmp_coll = <span class="keyword">static_cast&lt;</span><a class="code" href="classeic_1_1_calorimeter_hit_collection.html">eic::CalorimeterHitCollection</a>*<span class="keyword">&gt;</span>(coll);</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;      <span class="keyword">const</span> <span class="keyword">auto</span> tmp = (*tmp_coll)[<span class="keywordtype">id</span>.index];</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      m_rel_hits-&gt;emplace_back(tmp);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;      m_rel_hits-&gt;emplace_back(<span class="keyword">nullptr</span>);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    }</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;  }</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;  <span class="keywordflow">return</span> <span class="keyword">true</span>; <span class="comment">//TODO: check success</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;}</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a79bbe1cab384ab3a34e2bbea6731199b">  168</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_cluster_collection.html#a79bbe1cab384ab3a34e2bbea6731199b">ClusterCollection::push_back</a>(<a class="code" href="classeic_1_1_const_cluster.html">ConstCluster</a> <span class="keywordtype">object</span>) {</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;  <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a> = m_entries.size();</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;  <span class="keyword">auto</span> obj = <span class="keywordtype">object</span>.m_obj;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;  <span class="keywordflow">if</span> (obj-&gt;id.index == podio::ObjectID::untracked) {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    obj-&gt;id = {<a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a>, m_collectionID};</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    m_entries.push_back(obj);</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    m_rel_clusters_tmp.push_back(obj-&gt;m_clusters);</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    m_rel_hits_tmp.push_back(obj-&gt;m_hits);</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;  } <span class="keywordflow">else</span> {</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="keywordflow">throw</span> std::invalid_argument(<span class="stringliteral">&quot;Object already in a collection. Cannot add it to a second collection&quot;</span>);</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;  }</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;}</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection.html#a915d39fcc005c1f9c96f0a838df9dd39">  182</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classeic_1_1_cluster_collection.html#a915d39fcc005c1f9c96f0a838df9dd39">ClusterCollection::setBuffer</a>(<span class="keywordtype">void</span>* address) {</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;  <span class="keywordflow">if</span> (m_data) <span class="keyword">delete</span> m_data;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;  m_data = <span class="keyword">static_cast&lt;</span><a class="code" href="namespaceeic.html#a4b2806ccf4a8e9e4f7875e0b329d4700">ClusterDataContainer</a>*<span class="keyword">&gt;</span>(address);</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;}</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00187"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection_iterator.html#a37a5fbdbd684ddb64c6989cf75c78ef1">  187</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a> <a class="code" href="classeic_1_1_cluster_collection_iterator.html#a37a5fbdbd684ddb64c6989cf75c78ef1">ClusterCollectionIterator::operator*</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;  m_object.m_obj = (*m_collection)[m_index];</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;  <span class="keywordflow">return</span> m_object;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;}</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00192"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection_iterator.html#a46e519d160cf9ee7817fefb3c151adc0">  192</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_cluster.html">Cluster</a>* <a class="code" href="classeic_1_1_cluster_collection_iterator.html#a46e519d160cf9ee7817fefb3c151adc0">ClusterCollectionIterator::operator-&gt;</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;  m_object.m_obj = (*m_collection)[m_index];</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;  <span class="keywordflow">return</span> &amp;m_object;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;}</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno"><a class="line" href="classeic_1_1_cluster_collection_iterator.html#aaba5c1501fcf981d045b3dcdcf08f164">  197</a></span>&#160;<span class="keyword">const</span> <a class="code" href="classeic_1_1_cluster_collection_iterator.html">ClusterCollectionIterator</a>&amp; <a class="code" href="classeic_1_1_cluster_collection_iterator.html#aaba5c1501fcf981d045b3dcdcf08f164">ClusterCollectionIterator::operator++</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;  ++m_index;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;  <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;}</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div><div class="line"><a name="l00202"></a><span class="lineno"><a class="line" href="namespaceeic.html#ad27cb3d190da65688e90b512170160ad">  202</a></span>&#160;std::ostream&amp; <a class="code" href="namespaceeic.html#a207cb16b7a2df08e82d05c73c144487f">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classeic_1_1_cluster_collection.html">ClusterCollection</a>&amp; v) {</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;  <span class="keyword">const</span> <span class="keyword">auto</span> old_flags = o.flags();</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;  o &lt;&lt; <span class="stringliteral">&quot;          id:      energy:    position:positionError:       theta:         phi:directionError:&quot;</span> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;  <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; v.<a class="code" href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">size</a>(); ++i) {</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    o &lt;&lt; std::scientific &lt;&lt; std::showpos &lt;&lt; std::setw(12) &lt;&lt; v[i].id() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_cluster_collection.html#a23d88b44a888fe7a6ec9a040c2ba2407">energy</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_cluster_collection.html#a5ea636e5ebdc83b0ced98db2b37ba35c">theta</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;      &lt;&lt; std::setw(12) &lt;&lt; v[i].<a class="code" href="classeic_1_1_cluster_collection.html#a2452aca264f445750aa36ef3fbbc1580">phi</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;      &lt;&lt; std::endl;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    o &lt;&lt; <span class="stringliteral">&quot;      clusters : &quot;</span>;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> j = 0, N = v[i].clusters_size(); j &lt; N; ++j) {</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;      o &lt;&lt; v[i].clusters(j).id() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    }</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    o &lt;&lt; std::endl;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    o &lt;&lt; <span class="stringliteral">&quot;      hits : &quot;</span>;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> j = 0, N = v[i].hits_size(); j &lt; N; ++j) {</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;      o &lt;&lt; v[i].hits(j).id() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    }</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    o &lt;&lt; std::endl;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;  }</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;  o.flags(old_flags);</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;  <span class="keywordflow">return</span> o;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;}</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;} <span class="comment">// namespace eic</span></div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="ttc" id="classeic_1_1_cluster_obj_html"><div class="ttname"><a href="classeic_1_1_cluster_obj.html">eic::ClusterObj</a></div><div class="ttdef"><b>Definition:</b> <a href="_cluster_obj_8h_source.html#l00021">ClusterObj.h:21</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_ad532b11026e8f96ac806f345c9046f30"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#ad532b11026e8f96ac806f345c9046f30">eic::ClusterCollection::setReferences</a></div><div class="ttdeci">bool setReferences(const podio::ICollectionProvider *collectionProvider) override final</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00137">ClusterCollection.cc:137</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_iterator_html_a46e519d160cf9ee7817fefb3c151adc0"><div class="ttname"><a href="classeic_1_1_cluster_collection_iterator.html#a46e519d160cf9ee7817fefb3c151adc0">eic::ClusterCollectionIterator::operator-&gt;</a></div><div class="ttdeci">const Cluster * operator-&gt;() const</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00192">ClusterCollection.cc:192</a></div></div>
<div class="ttc" id="classeic_1_1_const_calorimeter_hit_html"><div class="ttname"><a href="classeic_1_1_const_calorimeter_hit.html">eic::ConstCalorimeterHit</a></div><div class="ttdef"><b>Definition:</b> <a href="_calorimeter_hit_const_8h_source.html#l00029">CalorimeterHitConst.h:29</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a1e0a38ddf496eee61e5b7b73812b69bf"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a1e0a38ddf496eee61e5b7b73812b69bf">eic::ClusterCollection::at</a></div><div class="ttdeci">const Cluster at(unsigned int index) const</div><div class="ttdoc">Returns the const object of given index. </div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00036">ClusterCollection.cc:36</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_html"><div class="ttname"><a href="classeic_1_1_cluster.html">eic::Cluster</a></div><div class="ttdef"><b>Definition:</b> <a href="_cluster_8h_source.html#l00029">Cluster.h:29</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a8ab71f2656724b8c370dbac47e9869b7"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a8ab71f2656724b8c370dbac47e9869b7">eic::ClusterCollection::prepareAfterRead</a></div><div class="ttdeci">void prepareAfterRead() override final</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00124">ClusterCollection.cc:124</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a26edef89c8964b3bd1d04374c2ecd9d9"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a26edef89c8964b3bd1d04374c2ecd9d9">eic::ClusterCollection::prepareForWrite</a></div><div class="ttdeci">void prepareForWrite() override final</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00090">ClusterCollection.cc:90</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a5ea636e5ebdc83b0ced98db2b37ba35c"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a5ea636e5ebdc83b0ced98db2b37ba35c">eic::ClusterCollection::theta</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; theta() const</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8h_source.html#l00202">ClusterCollection.h:202</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a1346e31bcd6c87de757cca70dcd1b8b6"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a1346e31bcd6c87de757cca70dcd1b8b6">eic::ClusterCollection::clear</a></div><div class="ttdeci">void clear() override final</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00061">ClusterCollection.cc:61</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_iterator_html_a37a5fbdbd684ddb64c6989cf75c78ef1"><div class="ttname"><a href="classeic_1_1_cluster_collection_iterator.html#a37a5fbdbd684ddb64c6989cf75c78ef1">eic::ClusterCollectionIterator::operator*</a></div><div class="ttdeci">const Cluster operator*() const</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00187">ClusterCollection.cc:187</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a79bbe1cab384ab3a34e2bbea6731199b"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a79bbe1cab384ab3a34e2bbea6731199b">eic::ClusterCollection::push_back</a></div><div class="ttdeci">void push_back(ConstCluster object)</div><div class="ttdoc">Append object to the collection. </div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00168">ClusterCollection.cc:168</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a23d88b44a888fe7a6ec9a040c2ba2407"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a23d88b44a888fe7a6ec9a040c2ba2407">eic::ClusterCollection::energy</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; energy() const</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8h_source.html#l00172">ClusterCollection.h:172</a></div></div>
<div class="ttc" id="namespaceeic_html_a207cb16b7a2df08e82d05c73c144487f"><div class="ttname"><a href="namespaceeic.html#a207cb16b7a2df08e82d05c73c144487f">eic::operator&lt;&lt;</a></div><div class="ttdeci">std::ostream &amp; operator&lt;&lt;(std::ostream &amp;o, const ConstCalorimeterHit &amp;value)</div><div class="ttdef"><b>Definition:</b> <a href="_calorimeter_hit_8cc_source.html#l00112">CalorimeterHit.cc:112</a></div></div>
<div class="ttc" id="classeic_1_1_calorimeter_hit_collection_html"><div class="ttname"><a href="classeic_1_1_calorimeter_hit_collection.html">eic::CalorimeterHitCollection</a></div><div class="ttdef"><b>Definition:</b> <a href="_calorimeter_hit_collection_8h_source.html#l00050">CalorimeterHitCollection.h:50</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_ac6eb35a42fe7b108febddc5547b624cd"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#ac6eb35a42fe7b108febddc5547b624cd">eic::ClusterCollection::~ClusterCollection</a></div><div class="ttdeci">~ClusterCollection()</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00024">ClusterCollection.cc:24</a></div></div>
<div class="ttc" id="_calorimeter_hit_collection_8h_html"><div class="ttname"><a href="_calorimeter_hit_collection_8h.html">CalorimeterHitCollection.h</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a3572bed117578a344b9529b467a3face"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a3572bed117578a344b9529b467a3face">eic::ClusterCollection::size</a></div><div class="ttdeci">size_t size() const override final</div><div class="ttdoc">number of elements in the collection </div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00048">ClusterCollection.cc:48</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html"><div class="ttname"><a href="classeic_1_1_cluster_collection.html">eic::ClusterCollection</a></div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8h_source.html#l00050">ClusterCollection.h:50</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a2452aca264f445750aa36ef3fbbc1580"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a2452aca264f445750aa36ef3fbbc1580">eic::ClusterCollection::phi</a></div><div class="ttdeci">const std::array&lt; float, arraysize &gt; phi() const</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8h_source.html#l00212">ClusterCollection.h:212</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a04df429e9bc0083748371067dc9b4a79"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a04df429e9bc0083748371067dc9b4a79">eic::ClusterCollection::operator[]</a></div><div class="ttdeci">const Cluster operator[](unsigned int index) const</div><div class="ttdoc">Returns the const object of given index. </div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00032">ClusterCollection.cc:32</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_ad0f736c97d234af7faf81f2316d89a36"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#ad0f736c97d234af7faf81f2316d89a36">eic::ClusterCollection::create</a></div><div class="ttdeci">Cluster create()</div><div class="ttdoc">Append a new object to the collection, and return this object. </div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00052">ClusterCollection.cc:52</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a915d39fcc005c1f9c96f0a838df9dd39"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a915d39fcc005c1f9c96f0a838df9dd39">eic::ClusterCollection::setBuffer</a></div><div class="ttdeci">void setBuffer(void *address) override final</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00182">ClusterCollection.cc:182</a></div></div>
<div class="ttc" id="classeic_1_1_const_cluster_html"><div class="ttname"><a href="classeic_1_1_const_cluster.html">eic::ConstCluster</a></div><div class="ttdef"><b>Definition:</b> <a href="_cluster_const_8h_source.html#l00027">ClusterConst.h:27</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_iterator_html"><div class="ttname"><a href="classeic_1_1_cluster_collection_iterator.html">eic::ClusterCollectionIterator</a></div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8h_source.html#l00029">ClusterCollection.h:29</a></div></div>
<div class="ttc" id="namespaceeic_html"><div class="ttname"><a href="namespaceeic.html">eic</a></div><div class="ttdef"><b>Definition:</b> <a href="_calorimeter_hit_8cc_source.html#l00014">CalorimeterHit.cc:14</a></div></div>
<div class="ttc" id="_cluster_collection_8h_html"><div class="ttname"><a href="_cluster_collection_8h.html">ClusterCollection.h</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_obj_html_aab30fa33cb765e4aa0f3540b308234a5"><div class="ttname"><a href="classeic_1_1_cluster_obj.html#aab30fa33cb765e4aa0f3540b308234a5">eic::ClusterObj::m_clusters</a></div><div class="ttdeci">std::vector&lt;::eic::ConstCluster &gt; * m_clusters</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_obj_8h_source.html#l00034">ClusterObj.h:34</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_html_a8fa56b59b339384399af2c26716ccae9"><div class="ttname"><a href="classeic_1_1_cluster_collection.html#a8fa56b59b339384399af2c26716ccae9">eic::ClusterCollection::ClusterCollection</a></div><div class="ttdeci">ClusterCollection()</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00015">ClusterCollection.cc:15</a></div></div>
<div class="ttc" id="namespaceeic_html_a4b2806ccf4a8e9e4f7875e0b329d4700"><div class="ttname"><a href="namespaceeic.html#a4b2806ccf4a8e9e4f7875e0b329d4700">eic::ClusterDataContainer</a></div><div class="ttdeci">std::vector&lt; ClusterData &gt; ClusterDataContainer</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8h_source.html#l00026">ClusterCollection.h:26</a></div></div>
<div class="ttc" id="classeic_1_1_cluster_collection_iterator_html_aaba5c1501fcf981d045b3dcdcf08f164"><div class="ttname"><a href="classeic_1_1_cluster_collection_iterator.html#aaba5c1501fcf981d045b3dcdcf08f164">eic::ClusterCollectionIterator::operator++</a></div><div class="ttdeci">const ClusterCollectionIterator &amp; operator++() const</div><div class="ttdef"><b>Definition:</b> <a href="_cluster_collection_8cc_source.html#l00197">ClusterCollection.cc:197</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
